<?
header("Content-Type: text/html; charset=utf-8");
require_once './lib.php' ;

/* Do not update cache unless called with parameter force_update=1 */
if ($_GET['force_update']==1) {
	define('MAGPIE_CACHE_AGE',1) ;
} 

/* Function used to sort rss items in chronological order */
function date_cmp($a, $b) {
   if ($a['date_timestamp'] == $b['date_timestamp'] ) {
		#descending order
		return ( strcmp($a['title'], $b['title']) == 1 ) ? -1 : 1; 
   }    
   return ($a['date_timestamp'] > $b['date_timestamp'] ) ? -1 : 1;
}

$TIMERANGE = ( $_REQUEST['hours'] ? $_REQUEST['hours']*3600 : 3600*24 ) ;

$data = file_get_contents($DATAFILE) ;
$data = unserialize( base64_decode($data) ) ;

$items = array();

// load times

if (file_exists($TIMEFILE)) {
	$time_table = file_get_contents($TIMEFILE) ;
	$time_table = unserialize($time_table) ;
} else {
	$time_table = array();
}

$channel_list= "<b>Sources</b><ul>";
for($i=0;$i<count($data['feeds']);$i++) {
	$rss = fetch_rss( $data['feeds'][$i] );
	if (!$rss) continue;
	if ($rss->image && $rss->image['url']) {
		$ico = $rss->image['url'] ;
	} else {
		$ico=channelFavicon($rss->channel['link']) ; 
	}
	$channel_list .= "<li><a href=\"" . $rss->channel['link'] . "\">" ;
	$channel_list .= "<img src=\"$ico\" height=\"16\" alt=\"icon\"/> " ; 
	$channel_list .= $rss->channel['title'] . "</a></li>" ;
	for ($j=0;$j<count($rss->items);$j++) {
		$x = $rss->items[$j] ;
		$x['channel_title'] = $rss->channel['title'];
		$x['channel_url'] = $rss->channel['link'] ;
		$x['favicon'] = $ico ;
		if ($x['date_timestamp'] == '') 
			$x['date_timestamp'] = create_time($x['title'] . $x['link']);
		$items[] = $x ;
	}
}
$channel_list .= "</ul>" ;
usort($items, 'date_cmp');
for($i=0;$i<count($items);$i++) {
	$summary = "" ;
	$item = $items[$i] ;
	$channel_title = $item['channel_title'];
	$channel_url = $item['channel_url'];
	$ico = $item['favicon'] ;
	$href = $item['link'];
	$item_id = md5($href) ;
	$title = $item['title'];	
	$summary = $item['summary'];	
	if (!$summary) $summary = $item['atom_content'];	
	$this_date = date('D d F, Y', $item['date_timestamp'] ) ;
	$time = date('H:i', $item['date_timestamp'] ) ;
	if ($this_date!=$date) {
		if ($date) {
			$out .= "</div>" ;
			$channel_url_old="" ;
		}

		$date = $this_date ;
		$out .= "<h1>$date</h1>\n" ;
	}
	if ($item_id==$_COOKIE['mark']) $markStatus="on" ;
	else $markStatus="off" ;


	if ($channel_url_old != $channel_url) {
		if ($channel_url_old) $out .= "</div>" ;
		$out .= "<div class=\"feed\">" ;
	}
	$out .= "<div class=\"item\" id=\"IITEM-$item_id\">" ;
	$out .="<img src=\"i/mark_$markStatus.gif\" id=\"IMARK$i\" alt=\"Click here to bookmark this link.\" />" ;
 
	if ($ico) $out .= "<img src=\"$ico\" alt=\"Channel Image\" title=\"Source favicon\" width=\"16\" height=\"16\" />" ;
	$out .= "<span class=\"time\">$time</span> " ;
	$out .= "<span class=\"title\" id=\"TITLE$i\">$title</span>" ;
	$out .= "<span class=\"source\"><a href=\"$href\">&#187; $channel_title</a></span>" ;
	$out .= delicious_tags($href) ;
	$out .= "<div class=\"excerpt\" id=\"ICONT$i\" >" ; 
	$out .= "$summary";
	$out .= "<br/><img src=\"i/del.icio.us.gif\" alt=\"add to del.icio.us\"/> <a href=\"javascript:deliciousPost('" . addslashes($href) ."','" . addslashes($title) . "');\">add to del.icio.us.</a>" ;
	$out .= "&nbsp;<a href=\"http://del.icio.us/url/" . md5($href) ."\">look up in del.icio.us.</a> " . delicious_tags($href) ;

	$out .= google_get_res($title,0) ;

	$channel_url_old=$channel_url; 
 
	$out .= " &nbsp; <img src=\"i/furl.gif\" alt=\"add to furl.net\"/> <a href=\"javascript:furlPost('$href','$title');\">add to furl</a>" ;
	$out .= "</div>\n" ;
	$out .= "</div>\n" ;

 
	if ( ($TIMERANGE>-1) && (time() - $item['date_timestamp'] > $TIMERANGE) ) break ;
}
$out .= "</div>" ; //Close the last "feed" div.

// save times
$ttime = serialize($time_table);
$fp = fopen($TIMEFILE,'w') ;
fputs($fp, $ttime) ;
fclose($fp) ;

$itemCount = $i+1 ;

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head profile="http://gmpg.org/xfn/1">
<title><?=$SITETITLE?></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="stylesheet" type="text/css" href="style.css" media="screen"/>
<link rel="shortcut icon" href="favicon.ico" type="image/x-icon" />

<script language="JavaScript" type="text/javascript"><!--
	var showDetails = <?= ( ($_COOKIE['showDetails']=="true") ? "true" : "false") ?>;
	var markID = '<?= $_COOKIE['mark'] ?>' ;
//-->
</script>
<script language="JavaScript" type="text/javascript" src="js/engine.js"></script>
</head>
<body onload="visible_mode(showDetails)">
<div id="navigation">
  	<a href="<?=$BASEURL?>"><img src="i/logo.gif" alt="<?=$SITETITLE?>" title="<?=$SITETITLE?>" /></a>
	&nbsp;&nbsp;
    <a href="index.php?hours=24">24h</a>
    <a href="index.php?hours=48">48h</a>
    <a href="index.php?hours=168">week</a>
    <a href="index.php?hours=-1">all</a>
	|
    <a href="javascript:visible_mode(true);">expand</a>
    <a href="javascript:visible_mode(false);">collapse</a>
	|
    <a href="cache/opml.xml">OPML</a>
	|
    <a href="#sources">SOURCES</a>
</div>
<div id="c1">&nbsp;123</div>
<div id="c2">&nbsp;123</div>
<div id="main">
<?php echo $out; ?>
</div>

<div id="sources">
    <?= $channel_list ?>
</div>

  <div id="footer">powered by <a href="http://lilina.sourceforge.net/"><img src="i/logo.gif" alt="lilina news aggregator" title="lilina news aggregator" /></a> v
    <?= $LILINAVERSION ?>
  </div>
</body>
</html>
